<template>
  <div class="examination-container flex column">
    <div class="entrance-container" v-if="rootStep === 1">
      <img src="/img/lab_entrance.png" alt="" />
      <div class="btn-group-container flex row content-center">
        <el-button
          type="danger"
          class="theme-red-button small"
          @click="rootStep++"
          >开始实验</el-button
        >
        <el-button type="info" class="theme-info-button small"
          >退出实验</el-button
        >
      </div>
    </div>
    <div class="video-container" v-for="(video, index) in videos" :key="index">
      <el-button
        v-if="rootStep === video.rootStep && video.canSkip"
        class="skip-button"
        type="danger"
        @click="rootStep = video.rootStep + 1"
        >跳过</el-button
      >
      <video
        v-if="rootStep === video.rootStep"
        :src="video.url"
        :ref="`video_${index + 1}`"
        class="video-style"
      ></video>
    </div>
    <div class="lab-container" v-show="rootStep === 3" v-if="rootStep <= 3">
      <VrVideo
        v-show="showVideo"
        :video="video"
        @recordingStart="recordingStart"
        @recordingEnd="recordingEnd"
        @finish="VideoFinish"
        @next="VrNext"
      ></VrVideo>
      <LabForm v-show="!showVideo" :step="step" @save="LabEnd"></LabForm>
    </div>
    <div class="finish-container" v-if="rootStep === 6">
      <div class="btn-container">
        <span>恭喜你已完成实验</span>
        <el-button class="theme-red-button small" @click="saveAndUpload"
          >完成并提交成绩</el-button
        >
      </div>
    </div>
    <AudioRecording
      ref="audioRecording"
      :afterRecording="afterRecording"
    ></AudioRecording>
  </div>
</template>

<script>
import { labs, answersheets } from "@/api";
import VrVideo from "./vrVideo";
import LabForm from "./lab";
import { mapGetters } from "vuex";
import AudioRecording from "@/components/audioRecording";

export default {
  name: "examination",
  components: {
    LabForm,
    VrVideo,
    AudioRecording
  },
  data() {
    return {
      lab: null,
      step: 1,
      totalStep: 2,
      showVideo: true,
      video: null,
      rootStep: 1,
      videoPlay: false,
      answers: [],
      vrData: [],
      videos: [
        {
          rootStep: 2,
          url: "http://0.0.0.0:3000/videos/书记01.mp4",
          canSkip: true
        },
        {
          rootStep: 4,
          url: "http://0.0.0.0:3000/videos/采访2.mp4",
          canSkip: true
        },
        {
          rootStep: 5,
          url: "http://0.0.0.0:3000/videos/书记02.mp4",
          canSkip: true
        }
      ],
      answer: null
    };
  },
  computed: {
    ...mapGetters({ isLogin: "accounts/isLogin" })
  },
  methods: {
    async fetchLabData() {
      try {
        let result = await labs.detail(1, {
          filters: {
            include: ["questions"]
          }
        });
        this.video = result.video || null;
        this.lab = result;
      } catch (err) {
        this.$message({
          type: "error",
          message: "网络错误"
        });
      }
    },
    recordingStart() {
      this.$refs["audioRecording"].start();
    },
    recordingEnd() {
      this.$refs["audioRecording"].stop();
    },
    async afterRecording(file) {
      console.log(file);
      await this.$refs["audioRecording"].clear();
    },
    VideoFinish(step) {
      this.step = step;
      this.showVideo = false;
    },
    VrNext(data) {
      this.vrData = data;
      this.rootStep = 4;
    },
    LabEnd(items) {
      // 答案数据在这里
      this.answers = items;
      this.showVideo = true;
    },
    async saveAndUpload() {
      window.finish = false;
      if (this.answers.length === 0) {
        return this.$message({
          type: "error",
          message: "请至少完成一部分习题"
        });
      }
      try {
        let res, answer;
        if (this.isLogin) {
          res = await answersheets.create({
            lab_id: 1,
            vr: 40,
            items: this.answers
          });
          answer = await answersheets.detail(res.id, {
            filters: {
              include: [
                "account",
                {
                  association: "answers",
                  include: ["question"]
                }
              ]
            }
          });
        } else {
          answer = await answersheets.pass({
            lab_id: 1,
            items: this.answers
          });
          answer.account = {
            name: "测试者"
          };
        }
        this.$message({
          type: "success",
          message: "答案提交成功"
        });
        this.$router.push({
          path: "/experiment-report",
          query: {
            data: answer
          }
        });
      } catch (err) {
        this.$message({
          type: "error",
          message: "实验数据异常,请重新进行实验"
        });
        throw err;
      }
    }
  },
  async created() {
    await this.fetchLabData();
  },
  watch: {
    rootStep: function(val) {
      let videoIndex = this.videos.findIndex(_val => _val.rootStep === val);
      if (videoIndex !== -1) {
        this.$nextTick(() => {
          let videoRef = `video_${videoIndex + 1}`;
          this.$refs[videoRef][0].addEventListener(
            "ended",
            () => {
              this.videoPlay = false;
              this.rootStep++;
            },
            false
          );
          setTimeout(() => {
            this.$refs[videoRef][0].play();
          }, 250);
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.examination-container {
  position: relative;
  .mock-message-blcok {
    position: absolute;
    top: 20%;
    right: 10%;
    z-index: 100;
  }
  .absolute-button-group {
    position: absolute;
    bottom: 10px;
    right: 10px;
    z-index: 99;
  }
}
.video-style {
  width: 100%;
}
.video-container {
  position: relative;
  .skip-button {
    z-index: 99;
    position: absolute;
    bottom: 20px;
    right: 20px;
  }
}
.entrance-container {
  position: relative;
  .btn-group-container {
    position: absolute;
    bottom: 15%;
    width: 100%;
    .el-button {
      width: 180px;
    }
  }
  img {
    width: 100%;
  }
}
.finish-container {
  position: relative;
  height: 250px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  .btn-container {
    display: flex;
    flex-direction: column;
    margin: auto;
    span {
      font-size: 24px;
      margin-bottom: 20px;
    }
  }
}
</style>
